## kadnode-2.3.0.tar.gz

=== Makefile ===

CFLAGS ?= -Os -Wall -Wwrite-strings -pedantic
CFLAGS += -std=gnu99 -I/usr/local/include $(CPPFLAGS)
LDFLAGS += -L/usr/local/lib -lc
FEATURES ?= dns lpd tls bob cmd debug nss #natpmp upnp

OBJS = build/searches.o build/kad.o build/log.o \
	build/conf.o build/net.o build/utils.o \
	build/announces.o build/peerfile.o

ifeq ($(OS),Windows_NT)
  OBJS += build/unix.o build/windows.o
else
  OBJS += build/unix.o
endif

.PHONY: all clean strip install kadnode libkadnode.so libkanode.a \
	libnss_kadnode arch-pkg deb-pkg osx-pkg manpage install uninstall

all: kadnode


ifeq ($(findstring lpd,$(FEATURES)),lpd)
  OBJS += build/ext-lpd.o
  CFLAGS += -DLPD
endif

ifeq ($(findstring bob,$(FEATURES)),bob)
  OBJS += build/ext-bob.o
  CFLAGS += -DBOB
  LDFLAGS += -lmbedtls -lmbedx509 -lmbedcrypto
endif

ifeq ($(findstring cmd,$(FEATURES)),cmd)
  OBJS += build/ext-cmd.o
  CFLAGS += -DCMD
endif

ifeq ($(findstring debug,$(FEATURES)),debug)
  CFLAGS += -g -DDEBUG
endif

ifeq ($(findstring dns,$(FEATURES)),dns)
  OBJS += build/ext-dns.o
  CFLAGS += -DDNS
endif

ifeq ($(findstring nss,$(FEATURES)),nss)
  OBJS += build/ext-nss.o
  CFLAGS += -DNSS
  EXTRA += libnss_kadnode
endif

ifeq ($(findstring tls,$(FEATURES)),tls)
  OBJS += build/ext-tls-client.o build/ext-tls-server.o
  CFLAGS += -DTLS
  LDFLAGS += -lmbedtls -lmbedx509 -lmbedcrypto
endif

ifeq ($(findstring upnp,$(FEATURES)),upnp)
  OBJS += build/upnp.o
  CFLAGS += -DFWD_UPNP
  LDFLAGS += -Wl,-Bdynamic -lminiupnpc
  ENABLE_FORWARDING = 1
endif

ifeq ($(findstring natpmp,$(FEATURES)),natpmp)
  OBJS += build/natpmp.o
  CFLAGS += -DFWD_NATPMP
  LDFLAGS += -Wl,-Bdynamic -lnatpmp
  ENABLE_FORWARDING = 1
endif

ifeq ($(ENABLE_FORWARDING),1)
  OBJS += build/ext-fwd.o
  CFLAGS += -DFWD
endif


build/%.o : src/%.c src/%.h
	$(CC) $(CFLAGS) -c -o $@ $<

libnss_kadnode:
	$(CC) $(CFLAGS) -fPIC -c -o build/ext-libnss.o src/ext-libnss.c
	$(CC) $(CFLAGS) $(LDFLAGS) -fPIC -shared -Wl,-soname,libnss_kadnode.so.2 -o build/libnss_kadnode-2.0.so build/ext-libnss.o

libkadnode.a: build/libkadnode.o $(OBJS)
	ar rcs build/libkadnode.a build/libkadnode.o $(OBJS)

libkadnode.so: CFLAGS += -fpic
libkadnode.so: build/libkadnode.o $(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared $(OBJS) build/libkadnode.o -o build/libkadnode.so

kadnode: build/main.o $(OBJS) $(EXTRA)
	$(CC) $(CFLAGS) build/main.o $(OBJS) $(LDFLAGS) -o build/kadnode
	ln -s kadnode build/kadnode-ctl 2> /dev/null || true

clean:
	rm -rf build/*

manpage:
	ronn --roff --manual=Kadnode\ Manual --organization=mwarning --date=2018-01-01 misc/manpage.md
	mv misc/manpage.1 misc/manpage

install:
	cp build/kadnode $(DESTDIR)/usr/bin/ 2> /dev/null || true
	ln -s kadnode $(DESTDIR)/usr/bin/kadnode-ctl || true
	cp build/libnss_kadnode-2.0.so $(DESTDIR)/lib/libnss_kadnode.so.2 2> /dev/null || true
	cp build/libkadnode.so $(DESTDIR)/lib/ 2> /dev/null || true
	sed -i -e '/kadnode/!s/^\(hosts:.*\)\s\{1,\}dns\(.*\)/\1 kadnode dns\2/' $(DESTDIR)/etc/nsswitch.conf 2> /dev/null || true

uninstall:
	rm $(DESTDIR)/usr/bin/kadnode 2> /dev/null || true
	rm $(DESTDIR)/usr/bin/kadnode-ctl 2> /dev/null || true
	rm $(DESTDIR)/lib/libnss_kadnode.so 2> /dev/null || true
	rm $(DESTDIR)/usr/lib/libkadnode.so 2> /dev/null || true
	sed -i -e 's/^\(hosts:.*\)kadnode \(.*\)/\1\2/' $(DESTDIR)/etc/nsswitch.conf 2> /dev/null || true

=== freebsd/Makefile ===
# Created by: Moritz Warning <moritzwarning@web.de>
# $FreeBSD$

PORTNAME=	kadnode
DISTVERSIONPREFIX=	v
DISTVERSION=	2.2.5
PORTREVISION=	0
CATEGORIES=	dns

MAINTAINER=	moritzwarning@web.de
COMMENT=	P2P name resolution daemon

LICENSE=	MIT
LICENSE_FILE=	${WRKSRC}/LICENSE

USES=		gmake
USE_GITHUB=	yes
GH_ACCOUNT=	mwarning
GH_PROJECT=	KadNode
USE_RC_SUBR=	kadnode

MAKE_ENV=	FEATURES="${FEATURES}"
SUB_FILES=	kadnode.conf

OPTIONS_DEFINE=	AUTH CMD DEBUG DNS LPD NATPMP NSS UPNP
OPTIONS_DEFAULT=	AUTH CMD LPD NSS
OPTIONS_SUB=	yes

AUTH_DESC=	Authorization support based on mbedtls
CMD_DESC=	Command line control tool kadnode-ctl
DEBUG_DESC=	Build with debug messages and symbols
DNS_DESC=	Include local DNS interface
LPD_DESC=	Local peer discovery
NATPMP_DESC=	NAT-PMP support (remote port forwarding on the router)
NSS_DESC=	Name Service Switch support to intercept host queries
UPNP_DESC=	UPnP support (remote port forwarding on the router)

AUTH_LIB_DEPENDS=	libmbedtls.so:security/mbedtls
AUTH_VARS=		FEATURES+="bob tls"

CMD_VARS=		FEATURES+="cmd"

DEBUG_VARS=		FEATURES+="debug"

DNS_VARS=		FEATURES+="dns"

LPD_VARS=		FEATURES+="lpd"

NATPMP_LIB_DEPENDS=	libnatpmp.so:net/libnatpmp
NATPMP_VARS=		FEATURES+="natpmp"

NSS_VARS=		FEATURES+="nss"

UPNP_LIB_DEPENDS=	libminiupnpc.so:net/miniupnpc
UPNP_VARS=		FEATURES+="upnp"

do-install:
	${INSTALL_PROGRAM} ${WRKSRC}/build/kadnode ${STAGEDIR}${PREFIX}/bin/
	${RLN} ${STAGEDIR}${PREFIX}/bin/kadnode ${STAGEDIR}${PREFIX}/bin/kadnode-ctl
	${MKDIR} ${STAGEDIR}${ETCDIR}
	${INSTALL_DATA} ${WRKSRC}/misc/peers.txt \
		${STAGEDIR}${ETCDIR}/peers.txt.sample
	${INSTALL_DATA} ${WRKDIR}/kadnode.conf \
		${STAGEDIR}${ETCDIR}/kadnode.conf.sample
	${INSTALL_MAN} ${WRKSRC}/misc/manpage \
		${STAGEDIR}${MANPREFIX}/man/man1/kadnode.1

do-install-NSS-on:
	${INSTALL_LIB} ${WRKSRC}/build/libnss_kadnode-2.0.so \
		${STAGEDIR}${PREFIX}/lib/nss_kadnode.so.1
	${RLN} ${STAGEDIR}${PREFIX}/lib/nss_kadnode.so.1 \
		${STAGEDIR}${PREFIX}/lib/nss_kadnode.so

.include <bsd.port.mk>

=== openwrt/kadnode/Makefile ===
include $(TOPDIR)/rules.mk


PKG_NAME:=kadnode
PKG_VERSION:=2.2.5
PKG_RELEASE:=1

PKG_LICENSE:=MIT

PKG_SOURCE_URL:=https://codeload.github.com/mwarning/KadNode/tar.gz/v$(PKG_VERSION)?
PKG_SOURCE:=kadnode-$(PKG_VERSION).tar.gz
PKG_HASH:=a72dc54d1869e47e374935cf44aa888a9b13c9dc017ae22e29cf13ead38a506b
PKG_BUILD_DIR:=$(BUILD_DIR)/KadNode-$(PKG_VERSION)


PKG_BUILD_PARALLEL:=1

include $(INCLUDE_DIR)/package.mk

define Package/kadnode
	SECTION:=net
	CATEGORY:=Network
	TITLE:=P2P DNS Resolver
	SUBMENU:=IP Addresses and Names
	URL:=https://github.com/mwarning/KadNode
	MENU:=1
	DEPENDS:=+KADNODE_ENABLE_BOB:libmbedtls +KADNODE_ENABLE_TLS:libmbedtls +KADNODE_ENABLE_UPNP:libminiupnpc +KADNODE_ENABLE_NATPMP:libnatpmp
	MAINTAINER:=Moritz Warning <moritzwarning@web.de>
endef

define Package/kadnode/description
	A P2P DNS system based on the BitTorrent network. It can be used as a decentralized DynDNS service.
endef

define Package/kadnode/config
	source "$(SOURCE)/Config.in"
endef

FEATURES = 

ifeq ($(CONFIG_KADNODE_ENABLE_CMD),y)
FEATURES += cmd
endif

ifeq ($(CONFIG_KADNODE_ENABLE_LPD),y)
FEATURES += lpd
endif

ifeq ($(CONFIG_KADNODE_ENABLE_TLS),y)
FEATURES += tls
endif

ifeq ($(CONFIG_KADNODE_ENABLE_BOB),y)
FEATURES += bob
endif

ifeq ($(CONFIG_KADNODE_ENABLE_DNS),y)
FEATURES += dns
endif

ifeq ($(CONFIG_KADNODE_ENABLE_UPNP),y)
FEATURES += upnp
endif

ifeq ($(CONFIG_KADNODE_ENABLE_NATPMP),y)
FEATURES += natpmp
endif

ifeq ($(CONFIG_KADNODE_ENABLE_DEBUG),y)
FEATURES += debug
endif

MAKE_FLAGS += FEATURES="$(FEATURES)"

# Make binary smaller
TARGET_CFLAGS += -ffunction-sections -fdata-sections
TARGET_LDFLAGS += -Wl,--gc-sections

define Package/kadnode/conffiles
/etc/config/kadnode
endef

define Package/kadnode/install
	$(INSTALL_DIR) $(1)/usr/bin
	$(INSTALL_BIN) $(PKG_BUILD_DIR)/build/kadnode $(1)/usr/bin/
ifeq ($(CONFIG_KADNODE_ENABLE_CMD),y)
	$(LN) /usr/bin/kadnode $(1)/usr/bin/kadnode-ctl
endif
	$(INSTALL_DIR) $(1)/etc/init.d
	$(INSTALL_BIN) files/kadnode.init $(1)/etc/init.d/kadnode
	$(INSTALL_DIR) $(1)/etc/config
	$(INSTALL_CONF) files/kadnode.config $(1)/etc/config/kadnode
	$(INSTALL_DIR) $(1)/etc/uci-defaults
	$(INSTALL_BIN) files/kadnode.postinst $(1)/etc/uci-defaults/99_kadnode
endef

$(eval $(call BuildPackage,kadnode))

=== debian/changelog ===
kadnode (2.3.0-1) stable; urgency=medium

  * update dht to 0.26
  * fix resolve peers to IPv6 address
  * ignore sigpipe globally (should fix some crashes)
  * fix ttl value for dns interface reply

 -- Moritz Warning <moritzwarning@web.de>  Sun, 09 Feb 2020 00:00:00 +0100

=== archlinux/PKGBUILD ===
# Maintainer: Moritz Warning <moritzwarning@web.de>

pkgname=kadnode
pkgver=2.2.5
pkgrel=1

pkgdesc='A P2P based DNS resolver'
arch=('x86_64' 'i686')
url='http://github.com/mwarning/KadNode'
license=('MIT')
depends=('mbedtls')

backup=('etc/kadnode/kadnode.conf' 'etc/kadnode/peers.txt')

#source=(https://github.com/mwarning/KadNode/archive/v${pkgver}.tar.gz)
source=(git+https://github.com/mwarning/KadNode.git)

md5sums=('SKIP')

install="kadnode.install"

build() {
	cd ${srcdir}/KadNode
	make clean
	make FEATURES="tls bob cmd lpd nss"
}

package() {
	cd ${srcdir}/KadNode

	install -Dm755 build/kadnode ${pkgdir}/usr/bin/kadnode
	install -Dm755 build/kadnode-ctl ${pkgdir}/usr/bin/kadnode-ctl

	install -Dm644 build/libnss_kadnode-2.0.so ${pkgdir}/usr/lib/libnss_kadnode.so.2

	# package systemd units go to /usr/lib/systemd, /etc is for admin override
	install -Dm644 archlinux/kadnode.service ${pkgdir}/usr/lib/systemd/system/kadnode.service
	install -Dm644 LICENSE ${pkgdir}/usr/share/licenses/${pkgname}/LICENSE
	install -Dm 644 misc/manpage ${pkgdir}/usr/share/man/man1/kadnode.1

	install -Dm644 misc/kadnode.conf ${pkgdir}/etc/kadnode/kadnode.conf
	install -Dm644 misc/peers.txt ${pkgdir}/etc/kadnode/peers.txt
}

=== debian/control ===
Source: kadnode
Section: net
Priority: optional
Maintainer: Moritz Warning <moritzwarning@web.de>
Build-Depends: debhelper (>=10)
Standards-Version: 4.1.4
Homepage: https://github.com/mwarning/kadnode

Package: kadnode
Architecture: any
Depends: libmbedtls (>=2.4.2) | libmbedtls10 (>=2.4.2) | libmbedtls12 (>=2.4.2), ${shlibs:Depends}, ${misc:Depends}, ${misc:Pre-Depends}
Description: decentralized DynDNS alternative
 KadNode is a P2P DNS resolver that intercepts system requests for the
 p2p TLD. The decentralized BitTorrent DHT network is network is used
 to find IP addresses. Domains can be ECC crypto key in hex notations
 or domains that are backed by a Public Key Infrastructure (PKI).

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export FEATURES="tls bob lpd cmd nss"

# https://wiki.debian.org/Multiarch/Implementation#dh.281.29_and_autotools
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Top directory of the source code
SRCTOP := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)

# Destination directory where files will be installed
DESTDIR = $(SRCTOP)/debian/kadnode

%:
	dh $@

override_dh_auto_install:
	install -s build/kadnode $(DESTDIR)/usr/bin/
	ln -s kadnode $(DESTDIR)/usr/bin/kadnode-ctl
	mkdir $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/
	install -s build/libnss_kadnode-2.0.so $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/
	ln -s libnss_kadnode-2.0.so $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/libnss_kadnode.so.2
	mkdir -p $(DESTDIR)/etc/kadnode
	cp misc/peers.txt $(DESTDIR)/etc/kadnode/
	cp misc/kadnode.conf $(DESTDIR)/etc/kadnode/

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/<project>-$1\.tar\.gz/ \
  https://github.com/mwarning/KadNode/releases .*/v?(\d\S+)\.tar\.gz
